const system = require("../../../system");
var APIBase = require("../../api.base");
var settings = require("../../../../config/settings");
var moment = require('moment')
class TradetransferAPI extends APIBase {
  constructor() {
    super();
    this.aliclient = system.getObject("util.aliyunClient");
    this.execlient = system.getObject("util.execClient");
    this.transferurl = settings.reqTransferurl();
    this.corderSve = system.getObject("service.dbcorder.orderinfoSve");
  }

  //订单创建
  async createtransfer(p, obj, req) {
    if (!obj.actionBody.BizId) {
      return {
        "errorCode": "error",
        "errorMsg": "订单号不能为空",
        "module": { "orderNumber": "" },
        "requestId": req.requestId,
        "success": false
      }
    }
    if (!obj.actionBody.UserName) {
      return {
        "errorCode": "error",
        "errorMsg": "用户不能为空",
        "module": { "orderNumber": "" },
        "requestId": req.requestId,
        "success": false
      }
    }
    if (!obj.actionBody.Mobile) {
      return {
        "errorCode": "error",
        "errorMsg": "用户手机号不能为空",
        "module": { "orderNumber": "" },
        "requestId": req.requestId,
        "success": false
      }
    }
    if (!obj.actionBody.Price) {
      return {
        "errorCode": "error",
        "errorMsg": "价格不能为空",
        "module": { "orderNumber": "" },
        "requestId": req.requestId,
        "success": false
      }
    }
    var a = (new Date()).Format("yyyy-MM-dd hh:mm:ss");
    var orderc = {
      "actionProcess": "ali",
      "actionType": "addOrder",
      "isUser": "yes",
      "actionBody":
      {
        "itemCode": "alitmtt",
        "channelParams": obj.actionBody,
        "channelUser": {
          "channelUserId": obj.actionBody.Mobile,
          "channelUserName": obj.actionBody.UserName,
          "channelUserMoblie": obj.actionBody.Mobile,
          "nickname": "",
          "orgName": "",
          "orgPath": ""
        },
        "channelOrder": {
          "channelServiceNo": obj.actionBody.BizId,
          "channelOrderNo": "",
          "needNo": obj.actionBody.BizId,
          "quantity": 1,
          "totalSum": parseInt(obj.actionBody.Price),
          "payTotalSum": parseInt(obj.actionBody.Price) * 0.2,
          "payStatus": "yfk",
          "payTime": (new Date()).Format("yyyy-MM-dd hh:mm:ss")
        }
      }
    }
    var orderinfo = await this.corderSve.createOrder(orderc.actionBody, req);
    if (orderinfo) {
      if (orderinfo.status == "1") {
        return {
          "errorCode": "OK",
          "errorMsg": "",
          "module": { "orderNumber": orderinfo.dataValue.fq_ordernum },
          "requestId": req.requestId,
          "success": true
        }
      } else if (orderinfo.status == "2") {
        return {
          "errorCode": "OK",
          "errorMsg": "订单已存在",
          "module": { "orderId": orderinfo.dataValue.fq_ordernum },
          "requestId": req.requestId,
          "success": true
        }
      }

    } else {
      return {
        "errorCode": "error",
        "errorMsg": "",
        "module": { "orderNumber": "" },
        "requestId": req.requestId,
        "success": false
      }
    }
  }

  //订单查询
  async ordersel(p, obj) {
    var url = this.transferurl + "api/transfer/tradeApi/queryOrderState";
    var transferinfo = await this.execlient.execPost(obj.actionBody, url);
    var a = JSON.parse(transferinfo.stdout)
    return a;
  }

  //订单关闭
  async orderclose(obj) {
    var url = this.transferurl + "api/transfer/tradeApi/closeOrder";
    var transferinfo = await this.execlient.execPost(obj, url);
    var a = JSON.parse(transferinfo.stdout)
    return a;

  }

  //业务员分配
  async fenpeiowner(obj) {
    if (!obj.BizId) {
      return {
        "errorCode": "error",
        "errorMsg": "订单号不能为空",
        "requestId": obj.requestId,
        "success": false
      }
    }
    var transferinfo = await this.findOne({ ali_bizid: obj.BizId });
  }


  //阿里网关
  async aliclienttransfer(obj) {
    if (obj.actionBody) {
      var rtn = await this.aliclient.reqbyget(obj.actionBody)
      return rtn;
    }
  }
}
module.exports = TradetransferAPI;
